;
; JPD_String test and demo
;
#include <MsgBoxConstants.au3>
#include <Array.au3>
#include "JPD_String.au3"

;To see an example and check a function remove ";" from the selected line

_StringDateConvert_Eval()
_StringIsDate_Eval()
_StringCount_Eval()
_StringFormatBytesSize_Eval()
_StringIsEndingWith_Eval()
_StringIsStartingWith_Eval()
_StringJoinArray_Eval()
_StringRemoveFrenchAccent_eval() ;
_StringPadLeft_Eval()
_StringPadRight_Eval()
_StringRemoveChars_Eval()
_StringStrip_Eval()
_StringTitleCaseFrench_eval()
_StringWSClean_Eval()

Exit

Func _StringDateConvert_Eval()
	;_sDtConvert($sDate, $sFormatIn = "DMY", $sFormatOut = "YMD")
	Local $sDate = _NowCalc(), $sCalcDate
	_CW($sDate, "Now YMD >")
	$sCalcDate = _StringDateConvert($sDate, "YMD", "DMY")
	_CW($sCalcDate, "Now DMY >")
	$sCalcDate = _StringDateConvert($sDate, "YMD", "MDY")
	_CW($sCalcDate, "Now MDY >")
EndFunc   ;==>_StringDateConvert_Eval

Func _StringIsDate_Eval()
	Local $sDate = "30/02/2019"
	If _StringIsDate($sDate, "DMY") Then
		_CW($sDate, "Valid Date: ", "")
	Else
		_CW($sDate, "Invalid Date: ", "")
	EndIf

	$sDate = "12/02/2019"
	If _StringIsDate($sDate, "DMY") Then
		_CW($sDate, "Valid Date: ", "")
	Else
		_CW($sDate, "invalid Date: ", "")
	EndIf
EndFunc   ;==>_StringIsDate_Eval

Func _StringFormatBytesSize_Eval()
	_CW(_StringFormatBytesSize(123456789, "B", 2), "size >")
	_CW(_StringFormatBytesSize(123456789, "MB", 2), "size >")
	_CW(_StringFormatBytesSize(123456789, "TB", 8), "size >")
EndFunc   ;==>_StringFormatBytesSize_Eval

Func _StringIsEndingWith_Eval()
	;_StringIsEndingWith($sInput, $sSearch, $bCaseSensitive = False)
	Local $sText = "The quick brown fox", $sEnd = "frog"
	If _StringIsEndingWith($sText, $sEnd) Then
		_MB_Info("'" & $sText & "' end with '" & $sEnd & "'")
	Else
		_MB_Info("'" & $sText & "' not ending with '" & $sEnd & "'")
	EndIf
EndFunc   ;==>_StringIsEndingWith_Eval

Func _StringRemoveFrenchAccent_eval()
	Local $sText = "l'élève de première année va à la piscine"
	_CW($sText)
	$sText = _StringRemoveFrenchAccent($sText)
	_CW($sText)
EndFunc   ;==>_StringRemoveFrenchAccent_eval

Func _StringJoinArray_Eval()
	Local $sText = "one/two/three/four/five"
	Local $aText = StringSplit($sText, "/")
	_ArrayDisplay($aText)
	_CW(_StringJoinArray($aText, "/"))
	_CW(_StringJoinArray($aText))
EndFunc   ;==>_StringJoinArray_Eval

Func _StringPadLeft_Eval()
	$sText = " Yes ="
	_CW_Fmt(_StringPadLeft($sText, "=", 20))
	$sText = "Another sentence to format"
	_CW_Fmt(_StringPadLeft($sText, "=", 20))
	_CW_Fmt(_StringPadLeft($sText, "=", 20, True))
EndFunc   ;==>_StringPadLeft_Eval

Func _StringPadRight_Eval()
	$sText = " Yes ="
	_CW_Fmt(_StringPadRight($sText, "=", 20))
	$sText = "Another sentence to format"
	_CW_Fmt(_StringPadRight($sText, "=", 40))
	_CW_Fmt(_StringPadRight($sText, "=", 20, True))
EndFunc   ;==>_StringPadRight_Eval

Func _StringRemoveChars_Eval()
	Local $sText = "If you can do it"
	_CW_Fmt($sText)
	_CW(_StringRemoveChars($sText, 8, 4))
	_CW(_StringRemoveChars($sText, 8, 45))
	$sText = "Test"
	_CW(_StringRemoveChars($sText, 3, 0))
EndFunc   ;==>_StringRemoveChars_Eval

Func _StringWSClean_Eval()
	Local $sText = @TAB & "This    is   a  new story." & @CR & @LF & "Once upon a time ...  "
	;_CW_Fmt ($sText)
	_CW_Fmt(_StringWSClean($sText))
EndFunc   ;==>_StringWSClean_Eval

Func _StringIsStartingWith_Eval()
	;_StringIsEndingWith($sInput, $sSearch, $bCaseSensitive = False)
	Local $sText = "The quick brown fox", $sStart = "the"
	If _StringIsStartingWith($sText, $sStart, True) Then
		_MB_Info("'" & $sText & "' Start with '" & $sStart & "'")
	Else
		_MB_Warning("'" & $sText & "' not starting with '" & $sStart & "'")
	EndIf
EndFunc   ;==>_StringIsStartingWith_Eval

Func _StringStrip_Eval()
	Local $sText = "=== The quick ==brown== fox ==="
	_CW(_StringStrip($sText, "="), "Trail >")
	_CW(_StringStrip($sText, "==="), "Trail >")
	_CW(_StringStrip($sText, "======="), "Trail >")
	_CW(_StringStrip($sText, "=", 1), "Lead  >")
	_CW(_StringStrip($sText, "=", 1, True), "Lead  >")
	_CW(_StringStrip($sText, "=", 3, True), "All   >")
EndFunc   ;==>_StringStrip_Eval

Func _StringTitleCaseFrench_eval()
	;_StringTitleCaseFrench($sString, $sLanguage = "FR")
	Local $sText = "l'élève de première année va à la piscine"
	_CW(_StringTitleCaseFrench($sText))
	Local $sText = "I can't get now, satisfaction ..."
	_CW(_StringTitleCaseFrench($sText))
EndFunc   ;==>_StringTitleCaseFrench_eval

Func _StringCount_Eval()
	_CW(_StringCount("The quick brown fox jump over the lazy dog", "x"))
	_CW(_StringCount("The quick brown fox jump over the lazy dog", "5"))
	_CW(_StringCount("The quick brown fox jump over the lazy dog", "fox"))
	_CW(_StringCount("another day ... another time", "other"))
EndFunc   ;==>_StringCount_Eval


;===========================================================================
Func _CW($sText, $sBOL = "Trace >", $sEOL = "<", $bNewLine = True)
	If $bNewLine Then $sEOL &= @CRLF
	ConsoleWrite($sBOL & $sText & $sEOL)
EndFunc   ;==>_CW

Func _CW_Fmt($sText, $sBOL = "Trace >", $sEOL = "<")
	Local $iLen = StringLen($sText)
	Local $iGap = Int($iLen / 10)
	If Mod($iLen, 10) > 0 Then $iGap += 1

	Local $sTitre10 = "", $sTitre1 = ""

	$sEOL &= @CRLF
	For $i = 1 To $iGap
		$sTitre10 &= _StringRepeat(" ", 9) & Mod($i, 10)
	Next
	$sTitre1 = _StringRepeat("1234567890", $iGap)
	ConsoleWrite($sBOL & $sTitre10 & $sEOL)
	ConsoleWrite($sBOL & $sTitre1 & $sEOL)
	ConsoleWrite($sBOL & $sText & $sEOL)
EndFunc   ;==>_CW_Fmt

Func _MB_Info($sMessage, $sTitle = "Information")
	MsgBox(BitOR($MB_SYSTEMMODAL, $MB_TOPMOST, $MB_ICONINFORMATION, $MB_OK), $sTitle, $sMessage)
EndFunc   ;==>_MB_Info

Func _MB_Warning($sMessage, $sTitle = "Warning")
	MsgBox(BitOR($MB_SYSTEMMODAL, $MB_TOPMOST, $MB_ICONWARNING, $MB_OK), $sTitle, $sMessage)
EndFunc   ;==>_MB_Warning
